Attribute VB_Name = "MForceFore"
' *********************************************************************
'  Copyright 1998-2000 Karl E. Peterson, All Rights Reserved
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

' Required Win32 API Declarations
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function AttachThreadInput Lib "user32" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function IsIconic Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long

' Constants used with APIs
Private Const SW_SHOW = 5
Private Const SW_RESTORE = 9

Public Function ForceForegroundWindow(ByVal hWnd As Long) As Boolean
   Dim ForeThreadID As Long
   Dim nRet As Long
   
   ' Make sure we have a top-level window.
   hWnd = GetTopLevel(hWnd)
   
   ' Nothing to do if already in foreground.
   If hWnd = GetForegroundWindow() Then
      ForceForegroundWindow = True
   Else
      ' First need to get the thread responsible for this window,
      ' and the thread for the foreground window.
      ForeThreadID = GetWindowThreadProcessId(GetForegroundWindow, ByVal 0&)
      
      ' By sharing input state, threads share their concept of
      ' the active window.
      If ForeThreadID <> App.ThreadID Then
         Call AttachThreadInput(ForeThreadID, App.ThreadID, True)
         nRet = SetForegroundWindow(hWnd)
         Call AttachThreadInput(ForeThreadID, App.ThreadID, False)
      Else
         nRet = SetForegroundWindow(hWnd)
      End If
      
      ' Restore and repaint
      If IsIconic(hWnd) Then
         Call ShowWindow(hWnd, SW_RESTORE)
      Else
         Call ShowWindow(hWnd, SW_SHOW)
      End If
      
      ' SetForegroundWindow return accurately reflects success.
      ForceForegroundWindow = CBool(nRet)
   End If
End Function

Public Function GetTopLevel(ByVal hChild As Long) As Long
   Dim hWnd As Long
   
   ' Read parent chain up to highest visible.
   hWnd = hChild
   Do While IsWindowVisible(GetParent(hWnd))
      hWnd = GetParent(hChild)
      hChild = hWnd
   Loop
   GetTopLevel = hWnd
End Function



