Attribute VB_Name = "MHung"
' *************************************************************************
'  Copyright 2000 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Private Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, lParam As Any, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long

Private Const WM_NULL As Long = &H0

Private Const SMTO_NORMAL As Long = &H0
Private Const SMTO_BLOCK As Long = &H1
Private Const SMTO_ABORTIFHUNG As Long = &H2

Private Const ERROR_TIMEOUT As Long = 1460

Public Function TaskResponding(ByVal hWnd As Long, _
   Optional ByVal Timeout As Long = 500) As Boolean
   ' Detection of "hung" status loosely based on KB article Q231844:
   ' http://support.microsoft.com/support/kb/articles/Q231/8/44.ASP
   Dim nRet As Long
   Dim nResult As Long
   
   Const flags As Long = SMTO_ABORTIFHUNG
   
   If IsWindow(hWnd) Then
      ' See if task responds to null msg.
      nRet = SendMessageTimeout(hWnd, WM_NULL, _
         0&, 0&, flags, Timeout, nResult)
      ' In NT, Err.LastDllError will be set to
      ' ERROR_TIMEOUT if window is non-responsive,
      ' but we can't count on that in Win9x.
      ' Instead, return True if SMTO call
      ' returns non-zero.
      TaskResponding = (nRet <> 0)
   End If
End Function
